import { useState, useEffect } from 'react';

var STATE = {};
var setStatesWithNs = {};
function createSharedState(ns, initState) {
    STATE[ns] = initState;
    setStatesWithNs[ns] = [];
}
function setSharedState(ns, newState) {
    var setStateFns = setStatesWithNs[ns];
    setStateFns.forEach(function (fn) { return fn(newState); });
    STATE[ns] = newState;
}
function useSharedState(ns) {
    if (STATE[ns] === undefined)
        throw ("The current namspace is not found. Please use createSharedState to create the state associated to namespace " + ns + " first");
    var _a = useState(STATE[ns]), state = _a[0], setState = _a[1];
    useEffect(function () {
        setStatesWithNs[ns].push(setState);
        return function () {
            setStatesWithNs[ns] = setStatesWithNs[ns].filter(function (d) { return d !== setState; });
        };
    }, []);
    var newSetState = setSharedState.bind(null, ns);
    return [state, newSetState];
}

export { createSharedState, useSharedState };
//# sourceMappingURL=index.es.js.map
